Code rewrite of config_fstab()
[grml-autoconfig.git] / autoconfig.functions
index 03e4aac..ae4edd7 100755 (executable)
@@ -4,7 +4,7 @@
 # Authors:       grml-team (grml.org), (c) Klaus Knopper <knopper@knopper.net>, (c) Michael Prokop <mika@grml.org>
 # Bug-Reports:   see http://grml.org/bugs/
 # License:       This file is licensed under the GPL v2.
-# Latest change: Fre Nov 10 00:33:15 CET 2006 [mika]
+# Latest change: Fre Apr 13 12:49:52 CEST 2007 [mika]
 ################################################################################
 
 # {{{ path, variables, signals, umask, zsh
@@ -197,7 +197,7 @@ config_language(){
 
  # set default to 'en' in live-cd mode if $LANGUAGE is not yet set:
  if [ -z "$INSTALLED" ] ; then
-    [ -n "$LANGUAGE" ] || LANGUAGE='en'
+    [ -n "$LANGUAGE" ] || LANGUAGE='en-utf8'
  fi
 
  # if bootoption lang is used update /etc/default/locale, otherwise *not*!
@@ -209,10 +209,11 @@ config_language(){
  if [ -z "$CONSOLEFONT" ] ; then
     if ! checkbootparam "nodefaultfont" >>$DEBUG 2>&1 ; then
        # [ -n "$UTF8" ] && CONSOLEFONT='LatArCyrHeb-16' || CONSOLEFONT='Lat15-Terminus16'
-       if [ -r /usr/share/consolefonts/Lat15-Terminus16.psf.gz ] ; then
-          CONSOLEFONT='Lat15-Terminus16'
+       # if [ -r /usr/share/consolefonts/Lat15-Terminus16.psf.gz ] ; then
+       if [ -r /usr/share/consolefonts/Uni3-Terminus16.psf.gz ] ; then
+          CONSOLEFONT='Uni3-Terminus16'
        else
-          ewarn "/usr/share/consolefonts/Lat15-Terminus16.psf.gz not available. Please upgrade package console-terminus." ; eend 1
+          ewarn "/usr/share/consolefonts/Uni3-Terminus16.psf.gz not available. Please upgrade package console-terminus." ; eend 1
        fi
     fi
  fi
@@ -260,6 +261,7 @@ config_language(){
    [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
 
    # write keyboard related variables to file for later use
+   [ -d /etc/sysconfig ] || mkdir /etc/sysconfig
    echo "KEYTABLE=\"$KEYTABLE\""          > /etc/sysconfig/keyboard
    echo "XKEYBOARD=\"$XKEYBOARD\""       >> /etc/sysconfig/keyboard
    echo "KDEKEYBOARD=\"$KDEKEYBOARD\""   >> /etc/sysconfig/keyboard
@@ -268,34 +270,43 @@ config_language(){
 
  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
 
-  # Set default keyboard before interactive setup
 if [ -n "$KEYTABLE" ] ; then
-   einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
-   loadkeys -q $KEYTABLE &
-   eend $?
-  fi
-
-  if [ -n "$CONSOLEFONT" ] ; then
-     einfo "Running consolechars using ${CONSOLEFONT}"
-     consolechars -f $CONSOLEFONT || consolechars -d
-     eend $?
+ # activate unicode console if running within utf8 environment
if [ -r /etc/default/locale ] ; then
+    if grep -q "LANG=.*UTF" /etc/default/locale ; then
+       if checkgrmlsmall && [ -z "$INSTALLED" ] ; then
+          ewarn "Not runnning unicode_start: grml-small with reduced language support detected." ; eend 0
+       else
+          einfo "Setting up unicode environment."
+          unicode_start ; eend $?
+       fi
+    fi
+ fi
 
-     if [ -n "$UTF8" ] ; then
-        einfo "Notice: run 'filterm - dynafont' in your shell to enable a unicode capable console."
-     fi
-  fi
+ # Set default keyboard before interactive setup
+ if [ -n "$KEYTABLE" ] ; then
+  einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
+  loadkeys -q $KEYTABLE &
+  eend $?
+ fi
 
-  # we have to set up all consoles, therefore loop it over all ttys:
-  if [ -n "$CHARMAP" ] ; then
-   einfo "Running consolechars for ${CHARMAP}"
-   NUM_CONSOLES=`fgconsole --next-available`
-   NUM_CONSOLES=`expr ${NUM_CONSOLES} - 1`
-   [ ${NUM_CONSOLES} -eq 1 ] && NUM_CONSOLES=6
-   for vc in `seq 0 ${NUM_CONSOLES}`  ; do
-     consolechars --tty=/dev/tty${vc} -m ${CHARMAP} ; RC=$?
-   done
-   eend ${RC}
-  fi
+ # we have to set up all consoles, therefore loop it over all ttys:
+ NUM_CONSOLES=`fgconsole --next-available`
+ NUM_CONSOLES=`expr ${NUM_CONSOLES} - 1`
+ [ ${NUM_CONSOLES} -eq 1 ] && NUM_CONSOLES=6
+ if [ -n "$CHARMAP" ] ; then
+    einfo "Running consolechars for ${CHARMAP}"
+    for vc in `seq 0 ${NUM_CONSOLES}`  ; do
+        consolechars --tty=/dev/tty${vc} -m ${CHARMAP} ; RC=$?
+    done
+    eend $RC
+ fi
+ if [ -n "$CONSOLEFONT" ] ; then
+    einfo "Running consolechars using ${CONSOLEFONT}"
+    for vc in `seq 0 ${NUM_CONSOLES}`  ; do
+        consolechars --tty=/dev/tty${vc} -f $CONSOLEFONT || consolechars --tty=/dev/tty${vc} -d
+    done
+    eend $?
+ fi
 
  eoutdent
 }
@@ -316,7 +327,13 @@ config_hostname(){
 
 # fstabuser (needed when running from harddisk with username != grml {{{
 config_userfstab(){
-  fstabuser=$(getent passwd 1000 | cut -d: -f1)
+  [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
+  if [ -n "$CONFIG_FSTAB_USER" ] ; then
+     fstabuser="$CONFIG_FSTAB_USER"
+  else
+     fstabuser=$(getent passwd 1000 | cut -d: -f1)
+  fi
+  # if not yet set fall back to default 'grml' user
   [ -n "$fstabuser" ] || fstabuser='grml'
 }
 # }}}
@@ -325,36 +342,76 @@ config_userfstab(){
 config_time(){
  # don't touch the files if running from harddisk:
  if [ -z "$INSTALLED" ]; then
-  UTC=""
-  checkbootparam utc >>$DEBUG 2>&1 && UTC="-u"
-  checkbootparam gmt >>$DEBUG 2>&1 && UTC="-u"
-  # hwclock uses the TZ variable
-  export TZ
-  hwclock $UTC -s
+    UTC=""
+    checkbootparam utc >>$DEBUG 2>&1 && UTC="-u"
+    checkbootparam gmt >>$DEBUG 2>&1 && UTC="-u"
+    # hwclock uses the TZ variable
+    [ -r /etc/timezone ] && TZ=$(cat /etc/timezone)
+    [ -n "$TZ" ] || TZ=Europe/Vienna
+
+    if ! [ -r /dev/rtc ] ; then
+      ewarn "Realtime clock not available, skipping execution of hwclock therefore." ; eend 0
+    else
+      ERROR=$(TZ="$TZ" hwclock $UTC -s 2>&1 | head -1) ; RC=$?
+      if [ -n "$ERROR" ] ; then
+         eindent
+         ERROR=$(TZ="$TZ" hwclock $UTC -s --directisa 2>&1 | head -1)
+         if [ -n "$ERROR" ] ; then
+            eerror "Problem running hwclock: $ERROR" ; eend 1
+         fi
+         eoutdent
+      fi
+    fi
  fi
 }
 # }}}
 
 # {{{ print kernel info
 config_kernel(){
-  vmware-detect &>/dev/null && VMWARE="inside ${WHITE}VMWare${NORMAL}"
+  vmware-detect &>/dev/null && VMWARE="inside ${WHITE}VMware/Qemu${NORMAL}"
+  [ -d /proc/xen ] && VMWARE='' # vmware-detect returns '0' when running with a Xen-enabled kernel
   einfo "Running Linux Kernel $KERNEL $VMWARE" ; eend 0
+  if [ -r /proc/cpuinfo ] ; then
+     if egrep -q '^flags.*(vmx|svm)' /proc/cpuinfo ; then
+       eindent
+       einfo 'CPU(s) featuring virtualization technology detected' ; eend 0
+       eoutdent
+     fi
+  fi
+  if [ -d /proc/xen ] ; then
+     eindent
+     einfo 'Running kernel featuring support for Xen detected' ; eend 0
+     eoutdent
+  fi
 }
 # }}}
 
 # {{{ vmware specific stuff
 config_vmware(){
 if checkbootparam novmware ; then
- ewarn "Skipping running vmware specific stuff as requested on boot commandline." ; eend 0
  ewarn "Skipping running vmware specific stuff as requested on boot commandline." ; eend 0
 else
- if [ -z "$INSTALLED" ]; then
-  if vmware-detect ; then
-    if [ -r /etc/X11/xorg.conf.vmware ] ; then
-      einfo "Copying /etc/X11/xorg.conf.vmware to /etc/X11/xorg.conf"
-      cp /etc/X11/xorg.conf.vmware /etc/X11/xorg.conf ; eend $?
-    fi
-  fi
- fi
+   if [ -z "$INSTALLED" ] ; then
+      if vmware-detect || stringinstring "BOOT_IMAGE=vmware " "$CMDLINE" ; then
+              if ! checkbootparam qemu ; then
+            if [ -r /etc/X11/xorg.conf.vmware ] ; then
+               einfo "VMware: Copying /etc/X11/xorg.conf.vmware to /etc/X11/xorg.conf"
+               cp /etc/X11/xorg.conf.vmware /etc/X11/xorg.conf ; eend $?
+            fi
+         fi
+      fi
+   fi
+fi
+}
+# }}}
+
+# {{{ qemu specific stuff
+config_qemu(){
+if checkbootparam qemu ; then
+   if [ -r /etc/X11/xorg.conf.example ] ; then
+      einfo "Qemu: Copying /etc/X11/xorg.conf.example to /etc/X11/xorg.conf"
+      cp /etc/X11/xorg.conf.example /etc/X11/xorg.conf ; eend $?
+   fi
 fi
 }
 # }}}
@@ -456,10 +513,21 @@ fi
 # activate serial console {{{
 config_console(){
 if checkbootparam "console"; then
-  einfo "Bootoption (for serial) console detected. Activating mgetty."
+  einfo "Bootoption (for serial) console detected."
+  eindent
+    if [ -r /etc/mgetty/mgetty.config ] ; then
+       MODE=$(getbootparam console | awk -F, '{print $2}')
+       MODE=${MODE%%n*}
+       [ -n "$MODE" ] || MODE=9600 # default mode
+       einfo "Setting speed in /etc/mgetty/mgetty.config to $MODE bps"
+       sed -i "s/speed [0-9]*/speed $MODE/" /etc/mgetty/mgetty.config ; eend $?
+    fi
+
+    einfo "Activating mgetty."
     sed -i 's/^#T0/T0/' /etc/inittab
     sed -i 's/^#T1/T1/' /etc/inittab
-  /sbin/telinit q ; eend $?
+    /sbin/telinit q ; eend $?
+  eoutdent
 fi
 }
 # }}}
@@ -477,7 +545,11 @@ done
 # {{{ Bring up loopback interface now
 config_local_net(){
  if [ -z "$INSTALLED" ] ; then
-    grep -q lo=lo /etc/network/run/ifstate 2>/dev/null || ifup lo
+    if grep -q 'iface lo inet loopback' /etc/network/interfaces 2>/dev/null ; then
+       grep -q lo=lo /etc/network/run/ifstate 2>/dev/null || ifup lo
+    else
+       ifconfig lo up
+    fi
  fi
 }
 # }}}
@@ -924,114 +996,117 @@ config_fstab(){
 NOSWAP="yes" # we do not use swap by default!
 if checkbootparam "swap" -o checkbootparam "anyswap" ; then
    NOSWAP=''
+   checkbootparam "anyswap" && export ANYSWAP='yes' || export ANYSWAP=""
 fi
 
 if checkbootparam "nofstab" -o checkbootparam "forensic" ; then
   ewarn "Skipping /etc/fstab creation as requested on boot commandline." ; eend 0
 else
-  checkbootparam "anyswap" && export ANYSWAP='yes' || export ANYSWAP=""
   einfo "Scanning for harddisk partitions and creating /etc/fstab. (Disable this via boot option: nofstab)"
   iszsh && setopt nonomatch
   if [ -x /usr/sbin/rebuildfstab ] ; then
-    config_userfstab || fstabuser=grml
-    /usr/sbin/rebuildfstab -r -u $fstabuser -g $fstabuser ; eend $?
+     config_userfstab || fstabuser=grml
+     /usr/sbin/rebuildfstab -r -u $fstabuser -g $fstabuser ; eend $?
   else
-    ewarn "Command rebuildfstab not found. Install package grml-rebuildfstab." ; eend 1
-  fi
-  if [ -e /var/run/rebuildfstab.pid ]; then
-    # Another instance of rebuildfstab, probably from hotplug, is still running, so just wait.
-    sleep 8
+     ewarn "Command rebuildfstab not found. Install package grml-rebuildfstab." ; eend 1
   fi
-fi
-# Scan for swap, config, homedir
-if [ -z "$NOSWAP" ]; then
-   einfo "Searching for swap partition(s) as requested."
-fi
-GRML_IMG=""
-GRML_SWP=""
-HOMEDIR="$(getbootparam home)"
-if [ -n "$partitions" ]; then
- while read p m f relax; do
-  case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
-  partoptions="users,exec"
-  fnew=""
-  case "$f" in swap)
-   eindent
-   if [ -n "$NOSWAP" ]; then
-    ewarn "Ignoring swap partition ${WHITE}$p${NORMAL} as requested." ; eend 0
-   else
-     case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
-             S1SUSP|S2SUSP|pmdisk|[zZ]*)
-                if [ -n "$ANYSWAP" ] ; then
-                  einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
-                  swapon $p 2>>$DEBUG ; eend $?
-                else
-                  ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
-                fi
-               ;;
-             *)
-                if [[ "$p" == LABEL* ]] ; then
-                   p=$(blkid -t $p | awk -F: '{print $1}')
-                fi
-                if grep -q $p /proc/swaps ; then
-                   ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
-                else
-                   einfo "Using swap partition ${WHITE}${p}${NORMAL}."
-                   swapon $p 2>>$DEBUG ; eend $?
-                fi
-               ;;
-     esac
-   fi
-   eoutdent
-   continue
-   ;;
-  esac
-# Create mountdir if not already present, but don't try to create stuff like /proc/bus/usb
-# Notice: grml-rebuildfstab >= 0.3-1 handles this now
-#  case "$m" in *none*|*proc*|*sys*|'') continue ;; esac
-#  [ -d "$m" ] || mkdir -p "$m"
-# WARNING: NTFS RW mounts are only safe since Kernel 2.6.11
-  [ "$f" = "ntfs" -a "${KERNEL%.*}" != "2.6" ] && continue
-  MOUNTOPTS="ro"
-  case "$f" in
-    vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
-    ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
-    *) continue ;;
-    # *) NONEFOUND='1'; continue ;;
-  esac
-  mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG || continue
-  # Activate swapfile, if exists
-  SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
-  if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
-   mount -o remount,rw $m
-   if swapon "$SWAPFILE" 2>>$DEBUG ; then
-    einfo "Using GRML swapfile ${SWAPFILE}."
-    fnew="$SWAPFILE swap swap defaults 0 0"
-    stringinfile "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
-    GRML_SWP="$GRML_SWP $SWAPFILE"
-    eend 0
-   fi
-   mount -o remount,ro $m 2>>$DEBUG
-  fi
-  IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
-  if [ -z "$INSTALLED" -a -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
-   if [ -n "$HOMEDIR" ]; then
-    if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
-     continue
-    fi
-   fi
-   if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
-    GRML_IMG="$IMAGE"
-    mount -o remount,ro $m 2>>$DEBUG
-   fi
-  fi
-  eend 0
-  # Umount, if not in use
-  umount -r $m 2>/dev/null
- done <<EOT
-$(cat /etc/fstab)
+fi # checkbootparam nofstab/forensic
+
+# Scan for swap, config, homedir - but only in live-mode
+if [ -z "$INSTALLED" ] ; then
+   [ -z "$NOSWAP" ] && einfo "Searching for swap partition(s) as requested."
+   GRML_IMG=""
+   GRML_SWP=""
+   HOMEDIR="$(getbootparam home)"
+   if [ -n "$partitions" ]; then
+      while read p m f relax; do
+        case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
+        partoptions="users,exec"
+        fnew=""
+        # it's a swap partition?
+        case "$f" in swap)
+          eindent
+          if [ -n "$NOSWAP" ]; then
+             ewarn "Ignoring swap partition ${WHITE}$p${NORMAL}. (Force usage via boot option 'swap', or execute grml-swapon)"
+             eend 0
+          else
+             case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
+                   S1SUSP|S2SUSP|pmdisk|[zZ]*)
+                     if [ -n "$ANYSWAP" ] ; then
+                        einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
+                        swapon $p 2>>$DEBUG ; eend $?
+                     else
+                        ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
+                     fi
+                     ;;
+                   *)
+                     if [[ "$p" == LABEL* ]] ; then
+                        p=$(blkid -t $p | awk -F: '{print $1}')
+                     fi
+                     if grep -q $p /proc/swaps ; then
+                        ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
+                     else
+                        einfo "Using swap partition ${WHITE}${p}${NORMAL}."
+                        swapon $p 2>>$DEBUG ; eend $?
+                     fi
+                     ;;
+             esac # dd-check
+          fi # -n "$NOSWAP
+          eoutdent
+          continue
+          ;;
+        esac # it's a swap partition?
+
+        # mount read-only
+        MOUNTOPTS="ro"
+        case "$f" in
+          vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
+          ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
+          *) continue ;;
+          # *) NONEFOUND='1'; continue ;;
+        esac
+   
+        # use a swapfile
+        if [ -z "$NOSWAP" ] ; then
+           mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG || continue
+           # Activate swapfile, if exists
+           SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
+        fi
+        if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
+           mount -o remount,rw $m && MOUNTED=1
+           if swapon "$SWAPFILE" 2>>$DEBUG ; then
+              einfo "Using GRML swapfile ${SWAPFILE}."
+              fnew="$SWAPFILE swap swap defaults 0 0"
+              stringinfile "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
+              GRML_SWP="$GRML_SWP $SWAPFILE"
+              eend 0
+           fi
+           mount -o remount,ro $m 2>>$DEBUG && MOUNTED=1
+        fi
+   
+        # use a image as home
+        IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
+        if [ -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
+           if [ -n "$HOMEDIR" ]; then
+              if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
+                 continue
+              fi
+           fi
+           if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
+              GRML_IMG="$IMAGE"
+              mount -o remount,ro $m 2>>$DEBUG && MOUNTED=1
+           fi
+        fi
+        eend 0
+   
+        # Umount, if not in use
+        [ -n "$MOUNTED" ] && umount -r $m 2>/dev/null
+   
+      done <<EOT
+      $(cat /etc/fstab)
 EOT
-fi
+   fi # -n $partitions
+fi # -z $INSTALLED
 }
 # }}}
 
@@ -1052,22 +1127,19 @@ if checkbootparam "ipv6"; then
   # we probably need some time until stateless autoconfiguration has happened
   sleep 2
   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
-  for DEVICE in `echo "$NETDEVICES"`
-  do
+  for DEVICE in `echo "$NETDEVICES"`; do
     eindent
-    einfo "$DEVICE:"
-    ADDRESSES="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{print $3}')"
-    COUNT="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{ sum += 1};END {print sum }')"
-    eindent
-    for ADDR in `echo "$ADDRESSES"`
-    do
-      einfo "$ADDR"
-    done
-    if [ "$COUNT" -eq "0" ]
-    then
-      einfo "(none)" ; eend 1
-    fi
-    eoutdent
+      einfo "$DEVICE:"
+      ADDRESSES="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{print $3}')"
+      COUNT="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{ sum += 1};END {print sum }')"
+      eindent
+        for ADDR in `echo "$ADDRESSES"` ; do
+            einfo "$ADDR"
+        done
+        if [ "$COUNT" -eq "0" ] ; then
+           einfo "(none)" ; eend 1
+        fi
+      eoutdent
     eoutdent
   done
   eend 0
@@ -1153,58 +1225,49 @@ config_cpu(){
 if checkbootparam "nocpu"; then
   ewarn "Skipping CPU detection as requested on boot commandline." ; eend 0
 else
-  if ! [ -x /etc/init.d/powernowd ] ; then
-    ewarn "Skipping CPU detection as powernowd dependencies are not fulfilled." ; eend 1
-  elif [ ! -e /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq -o ! -e /lib/modules/${KERNEL}/kernel/drivers/cpufreq ] ; then
-    ewarn "Skipping CPU detection as module dependencies are not fulfilled." ; eend 1
-  else
-    if [[ `grep -c processor /proc/cpuinfo` -gt 1 ]] ; then
-      einfo "Detecting CPU:"
-      CPU=$(awk -F: '/^processor/{printf "     Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG)
-      echo $CPU | sed 's/ \{1,\}/ /g'
-      eend 0
-    else
-      einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
-    fi
-    if /usr/sbin/laptop-detect ; then
-    einfo "Detected Laptop - trying to use cpu frequency scaling:"
-#      loadcpumod() {
-#      for module in /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq/*.ko /lib/modules/${KERNEL}/kernel/drivers/cpufreq/*.ko ; do
-#    # modprobe ${${${${(f)"$(_call_program modules ${(M)words[1]##*/}modprobe -l | grep cpufreq 2>>$DEBUG)"}:#}##*/}%.*}
-#        modprobe `basename ${module%%\.ko}` 1>>$DEBUG 2>&1
-#      done
-#      }
-#    CPU=$(grep 'model name' /proc/cpuinfo | cut -b14- | head -1)
-#    eindent
-#    if [[ $CPU = *Intel* ]] ; then
-#      einfo "Detected CPU is of type Intel - loading modules and starting cpudyn."
-#      local DETECTED=1
-#      loadcpumod
-#      /etc/init.d/cpudyn start 1>>$DEBUG ; eend $?
-#    fi
-#    if [[ $CPU = *AMD* ]] ; then
-#      einfo "Detected CPU is of type AMD - loading modules and starting powernowd."
-#      local DETECTED=1
-#      loadcpumod
-#      /etc/init.d/powernowd start 1>>$DEBUG ; eend $?
-#    fi
-
-     eindent
-     if [ -r /usr/bin/cpufreq-detect.sh ] ; then
-       . /usr/bin/cpufreq-detect.sh
-       if [ -n "$MODULE" -a "$MODULE" != none ]; then
-         einfo "Loading module ${MODULE} and starting powernowd."
-         modprobe cpufreq_userspace 1>>$DEBUG
-         modprobe "$MODULE" 1>>$DEBUG || modprobe "$MODULE_FALLBACK" 1>>$DEBUG
-         /etc/init.d/powernowd start 1>>$DEBUG ; eend $?
-       else
-         ewarn "Could not detect an appropriate CPU for use with powernowd - skipping." && eend 1
-       fi
-     fi
-     eoutdent
+  # check module dependencies
+  cpufreq_check() {
+   if [ -e /lib64 ] ; then
+      [ -e /lib/modules/${KERNEL}/kernel/arch/x86_64/kernel/cpufreq ] || return 1
+   else
+      [ -e /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq -o ! -e /lib/modules/${KERNEL}/kernel/drivers/cpufreq ] || return 1
    fi
+  }
+
+  if [[ `grep -c processor /proc/cpuinfo` -gt 1 ]] ; then
+     einfo "Detecting CPU:"
+     CPU=$(awk -F: '/^processor/{printf "      Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG)
+     echo $CPU | sed 's/ \{1,\}/ /g'
+     eend 0
+  else
+     einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
   fi
-fi
+
+  if ! cpufreq_check ; then
+    ewarn "Skipping cpufreq setup as module dependencies are not fulfilled." ; eend 1
+  else
+    if /usr/sbin/laptop-detect ; then
+       einfo "Detected Laptop - trying to use cpu frequency scaling:"
+       if [ -r /usr/bin/cpufreq-detect.sh ] ; then
+          eindent
+          . /usr/bin/cpufreq-detect.sh
+          if [ -n "$MODULE" -a "$MODULE" != none ]; then
+             einfo "Loading modules ${MODULE} and cpufreq_ondemand, setting ondemand governor"
+             modprobe "$MODULE" 1>>$DEBUG || modprobe "$MODULE_FALLBACK" 1>>$DEBUG
+             if modprobe cpufreq_ondemand && RC=0 || RC=1 ; then
+                for file in $(find /sys/devices/system/cpu/ -name scaling_governor 2>/dev/null) ; do
+                    echo ondemand > $file
+                done
+             fi
+             eend $RC
+          else
+             ewarn "Could not detect an appropriate CPU for use with cpu frequency scaling - skipping." && eend 1
+          fi
+          eoutdent
+       fi # cpufreq-detect
+    fi # laptop-detect
+  fi # cpufreq_check
+fi # checkbootparam nocpu
 }
 # }}}
 
@@ -1248,79 +1311,85 @@ fi
 
 # {{{ Check for persistent homedir option and eventually mount /home from there, or use a loopback file.
 config_homedir(){
-HOMEDIR="$(getbootparam home)"
-MYHOMEDEVICE=""
-MYHOMEMOUNTPOINT=""
-MYHOMEDIR=""
-if [ -n "$HOMEDIR" ]; then
-  einfo "Bootoption home detected." && eend 0
-  case "$HOMEDIR" in
-    /dev/*)
-    MYHOMEDEVICE="${HOMEDIR##/dev/}"
-    MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
-    MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
-    MYHOMEDIR="/mnt/${HOMEDIR##/dev/}"
-  ;;
-    /mnt/*)
-    MYHOMEDEVICE="${HOMEDIR##/mnt/}"
-    MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
-    MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
-    MYHOMEDIR="$HOMEDIR"
-  ;;
-    [Aa][Uu][Tt][Oo]|[Ss][Cc][Aa][Nn]|[Ff][Ii][Nn][Dd])
-    MYHOMEDIR="$(findfile grml.img)"
-    MYHOMEDEVICE="${MYHOMEDIR##/mnt/}"
-    MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
-    MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
-  ;;
-  *)
-    eerror "Invalid home= option '$HOMEDIR' specified (must start with /dev/ or /mnt/ or 'scan')." ; eend 1
-    eerror "Option ignored." ; eend 1
-  ;;
-  esac
-fi
-
-if [ -n "$MYHOMEDIR" ]; then
-  if trymount "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"; then
-    [ -f "$MYHOMEMOUNTPOINT/grml.img" ] && MYHOMEDIR="$MYHOMEMOUNTPOINT/grml.img"
-    while read device mountpoint fs relax; do
-      case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
-        case "$fs" in *[Nn][Tt][Ff][Ss]*)
-          umount "$MYHOMEMOUNTPOINT"; eerror "Error: will not mount NTFS filesystem on $MYHOMEDEVICE read/write!" ; eend 1
-          break
-        ;;
-        *[Ff][Aa][Tt]*)
-        # Note: This currently won't work with encrypted partitions
-        umount "$MYHOMEMOUNTPOINT"; mount -t vfat -o rw,uid=grml,gid=grml,umask=002 "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"
-        if [ ! -f "$MYHOMEDIR" ]; then
-          ewarn "WARNING: FAT32 is not a good filesystem option for /home/grml (missing socket/symlink support)."
-          ewarn "WARNING: Better use an ext2 loopback file on this device, and boot with home=$MYHOMEDEVICE/grml.img."
-        fi
-        ;;
-      esac
-      if mount -o remount,rw "$MYHOMEMOUNTPOINT"; then
-        einfo "Mounting ${WHITE}$MYHOMEDIR${NORMAL} as ${WHITE}/home/grml${NORMAL}."
-        if [ -f "$MYHOMEDIR" ]; then
-          # It's a loopback file, mount it over the /home/grml directory
-          trymount "$MYHOMEDIR" /home/grml
-          RC="$?"
-          [ "$RC" = "0" ] && ERROR="$(mount -o remount,rw /home/grml 2>&1)"
-          RC="$?"
-        else
-          # Do a --bind mount
-          ERROR="$(mount --bind "$MYHOMEDIR" /home/grml 2>&1)"
-          RC="$?"
-        fi
-        [ "$RC" = "0" ] && eend 0 || ( eerror "${ERROR}" ; eend 1 )
-      fi
-      break
+if checkbootparam home ; then
+   HOMEDIR="$(getbootparam home)"
+   MYHOMEDEVICE=""
+   MYHOMEMOUNTPOINT=""
+   MYHOMEDIR=""
+   if [ -n "$HOMEDIR" ]; then
+      einfo "Bootoption home detected." && eend 0
+      case "$HOMEDIR" in
+        /dev/*)
+        MYHOMEDEVICE="${HOMEDIR##/dev/}"
+        MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
+        MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
+        MYHOMEDIR="/mnt/${HOMEDIR##/dev/}"
+      ;;
+        /mnt/*)
+        MYHOMEDEVICE="${HOMEDIR##/mnt/}"
+        MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
+        MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
+        MYHOMEDIR="$HOMEDIR"
+      ;;
+        [Aa][Uu][Tt][Oo]|[Ss][Cc][Aa][Nn]|[Ff][Ii][Nn][Dd])
+        MYHOMEDIR="$(findfile grml.img)"
+        MYHOMEDEVICE="${MYHOMEDIR##/mnt/}"
+        MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
+        MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
       ;;
-    esac
-  done <<EOT
-$(cat /proc/mounts)
+      *)
+        eerror "Invalid home= option '$HOMEDIR' specified (must start with /dev/ or /mnt/ or 'scan')." ; eend 1
+        eerror "Option ignored." ; eend 1
+      ;;
+      esac
+   fi # -n $HOMEDIR
+
+   if [ -n "$MYHOMEDIR" ]; then
+      if trymount "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"; then
+         [ -f "$MYHOMEMOUNTPOINT/grml.img" ] && MYHOMEDIR="$MYHOMEMOUNTPOINT/grml.img"
+         while read device mountpoint fs relax; do
+           case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
+             case "$fs" in
+               *[Nn][Tt][Ff][Ss]*)
+                 umount "$MYHOMEMOUNTPOINT"; eerror "Error: will not mount NTFS filesystem on $MYHOMEDEVICE read/write!" ; eend 1
+                 break
+                 ;;
+               *[Ff][Aa][Tt]*)
+                 # Note: This currently won't work with encrypted partitions
+                 umount "$MYHOMEMOUNTPOINT"; mount -t vfat -o rw,uid=grml,gid=grml,umask=002 "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"
+                 if [ ! -f "$MYHOMEDIR" ]; then
+                    ewarn "WARNING: FAT32 is not a good filesystem option for /home/grml (missing socket/symlink support)."
+                    ewarn "WARNING: Better use an ext2 loopback file on this device, and boot with home=$MYHOMEDEVICE/grml.img."
+                 fi
+                 ;;
+             esac
+
+             if mount -o remount,rw "$MYHOMEMOUNTPOINT"; then
+                einfo "Mounting ${WHITE}$MYHOMEDIR${NORMAL} as ${WHITE}/home/grml${NORMAL}."
+                if [ -f "$MYHOMEDIR" ]; then
+                   # It's a loopback file, mount it over the /home/grml directory
+                   trymount "$MYHOMEDIR" /home/grml
+                   RC="$?"
+                   [ "$RC" = "0" ] && ERROR="$(mount -o remount,rw /home/grml 2>&1)"
+                   RC="$?"
+                else
+                   # Do a --bind mount
+                   ERROR="$(mount --bind "$MYHOMEDIR" /home/grml 2>&1)"
+                   RC="$?"
+                fi # -f $MYHOMEDIR
+
+                [ "$RC" = "0" ] && eend 0 || ( eerror "${ERROR}" ; eend 1 )
+
+             fi #  mount -o remount,rw,...
+           break
+           ;;
+           esac # case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
+         done <<EOT
+         $(cat /proc/mounts)
 EOT
-  fi
-fi
+     fi # if trymount ...
+   fi # -n $MYHOMEDIR
+fi # checkbootparam home
 }
 # }}}
 
@@ -1586,9 +1655,17 @@ if checkbootparam startx ; then
 sudo -u $fstabuser -i /usr/bin/grml-x $WINDOWMANAGER 1>>$DEBUG
 EOF
    chmod 755 /etc/init.d/xstartup
-   sed -i 's/^allowed_users=.*/allowed_users=anybody/' /etc/X11/Xwrapper.config
-   sed -i 's#^6.*#6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"#'   /etc/inittab
+
+   sed -i 's#^6:.*#6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"#' /etc/inittab
+
    /sbin/telinit q ; eend $?
+
+   if grep -q '^allowed_users=' /etc/X11/Xwrapper.config ; then
+      sed -i 's/^allowed_users=.*/allowed_users=anybody/' /etc/X11/Xwrapper.config
+   else
+      echo 'allowed_users=anybody' >> /etc/X11/Xwrapper.config
+   fi
+
   else
     eerror "We are not running from CD - startx will not work, skipping it.
      Please use something like xdm, gdm or kdm for starting X on a harddisk system!" ; eend 1
@@ -1891,8 +1968,9 @@ fi
 config_swraid(){
   if [ -z "$INSTALLED" ] ; then
   # notice: checkbootparam "forensic" is just for users who don't know how to really use the bootoption
-  if checkbootparam "noraid" -o checkbootparam "forensic" -o checkbootparam "raid=noautodetect" ; then
-     ewarn "Skipping search for SW-RAID as requested on boot commandline." ; eend 0
+  if checkbootparam 'noraid'   -o checkbootparam 'noswraid' -o \
+     checkbootparam 'forensic' -o checkbootparam 'raid=noautodetect' ; then
+     ewarn "Skipping SW-RAID code as requested on boot commandline." ; eend 0
   else
     if ! [ -x /sbin/mdadm ] ; then
        eerror "mdadm not available, can not execute it." ; eend 1
@@ -1901,47 +1979,53 @@ config_swraid(){
        # if ! egrep -qv '^(MAILADDR.*|#.*|)$' /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
        # find out whether we have a valid configuration file already
        if ! grep -q ARRAY /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
-         einfo "Creating /etc/mdadm/mdadm.conf"
-         [ -r /etc/mdadm/mdadm.conf ] && mv /etc/mdadm/mdadm.conf /etc/mdadm/mdadm.conf.old
-         MDADM_MAILADDR='root' /usr/share/mdadm/mkconf > /etc/mdadm/mdadm.conf ; eend $?
-       else
-         ewarn "/etc/mdadm/mdadm.conf looks like a configured mdadm setup, will not touch it." ; eend 0
+          einfo "Creating /etc/mdadm/mdadm.conf for use with mdadm."
+          [ -r /etc/mdadm/mdadm.conf ] && mv /etc/mdadm/mdadm.conf /etc/mdadm/mdadm.conf.old
+          MDADM_MAILADDR__='root' /usr/share/mdadm/mkconf > /etc/mdadm/mdadm.conf ; eend $?
+        else
+          ewarn "/etc/mdadm/mdadm.conf looks like a configured mdadm setup, will not touch it." ; eend 0
        fi
 
-       einfo "Searching for software RAID arrays (disable via bootoption noraid):"
-       eindent
-         IFSOLD=${IFS:-}
-         IFS='
+       if ! checkbootparam 'swraid' ; then
+          eindent
+          einfo "Just run 'Start mdadm-raid' to assemble md arrays or boot using 'swraid' as bootoption for autostart."
+          eoutdent
+       else
+          einfo "Bootoption swraid found. Searching for software RAID arrays:"
+          eindent
+           IFSOLD=${IFS:-}
+           IFS='
 '
-         for line in $(mdadm --assemble --scan --auto=yes --symlink=no 2>&1) ; do
-             case $line in
-               *'No arrays found'*)
-                 ewarn "$line" ; eend 0
-                 ;;
-               *)
-                 einfo "$line" ; eend 0
-                 ;;
-             esac
-         done
-         IFS=$IFSOLD
-       eoutdent
+           for line in $(mdadm --assemble --scan --auto=yes --symlink=no 2>&1) ; do
+               case $line in
+                 *'No arrays found'*)
+                   ewarn "$line" ; eend 0
+                   ;;
+                 *)
+                   einfo "$line" ; eend 0
+                   ;;
+               esac
+           done
+           IFS=$IFSOLD
+         eoutdent
 
-       if [ -r /proc/mdstat ] ; then
-          eindent
-          MDSTAT=$(grep '^md[0-9]' /proc/mdstat)
-          if [ -z "$MDSTAT" ] ; then
-             ewarn "No active arrays found" ; eend 0
-          else
-             IFSOLD=${IFS:-}
-             IFS='
+         if [ -r /proc/mdstat ] ; then
+            eindent
+            MDSTAT=$(grep '^md[0-9]' /proc/mdstat)
+            if [ -z "$MDSTAT" ] ; then
+               ewarn "No active arrays found" ; eend 0
+            else
+               IFSOLD=${IFS:-}
+               IFS='
 '
-             for line in $(grep '^md[0-9]' /proc/mdstat) ; do
-                 einfo "active arrays: $line" ; eend 0
-             done
-             IFS=$IFSOLD
-          fi
-          eoutdent
-       fi
+               for line in $(grep '^md[0-9]' /proc/mdstat) ; do
+                   einfo "active arrays: $line" ; eend 0
+               done
+               IFS=$IFSOLD
+            fi
+            eoutdent
+         fi # /proc/mdstat
+       fi # bootoption swraid
 
      fi # is /sbin/mdadm executable?
   fi # check for bootoptions
@@ -2053,6 +2137,18 @@ fi
 }
 # }}}
 
+# {{{ Support customization
+config_distri(){
+if checkbootparam "distri"; then
+  DISTRI="$(getbootparam 'distri' 2>>$DEBUG)"
+  if [ -r /cdrom/desktop/"$DISTRI".jpg ] ; then
+     [ -n "$BOOTDEBUG" ] && einfo "Debug: bootoption distri found and file /cdrom/desktop/$DISTRI present" && eend 0
+     cp /cdrom/desktop/"$DISTRI".jpg /usr/share/grml/desktop.jpg
+  fi
+fi
+}
+# }}}
+
 ### {{{ backwards compatible stuff
 config_environment(){
   ewarn "config_environment is deprecated. Please set CONFIG_ENVIRONMENT in /etc/grml/autoconfig to 'no'." ; eend 0